{smcl}
{* *! version 0.2.3 05 Sep 2023}{...}
{vieweralsosee "" "--"}{...}
{vieweralsosee "gigs: Conversion functions" "help ig_nbs"}{...}
{vieweralsosee "gigs: Classification functions" "help classify_sga"}{...}

{hi: help ig_nbs, help classify_sga}{right: ({browse "https://www.overleaf.com/project/641db63564edd62fb54c963b":SJXX-X: st0001})}
{hline}

{title:Title}

{p2colset 5 17 19 2}{...}
{p2col :{hi:gigs} {hline 2} Standardising child growth assessment with extensions to egen}
{p2colreset}{...}

{marker description}{...}
{title:Description}

{pstd} Amongst other aims, the Guidance for International Growth Standards 
 (GIGS) project is intended to make child growth assessment more accessible 
 and repeatable in code. As part of GIGS, we have implemented the growth 
 standards from the World Health Organisation and INTERGROWTH-21st project in 
 Stata.
 
{p 4 4 2}We have developed multiple functions for {cmd:egen}, which are 
 described in the documentation pages linked to from the 'Also see' section on 
 this page. These functions either convert between anthropometric measures and 
 z-scores/percentiles, or classify growth according to literature-based 
 cut-offs, including from the DHS.

{marker authors}{...}
{title:Authors}

{pstd}Simon R. Parker{p_end}
{pstd}Maternal, Adolescent, Reproductive, and Child Health (MARCH) Center{p_end}
{pstd}London School of Hygiene and Tropical Medicine{p_end}
{pstd}London, U.K.{p_end}
{pstd}simon.parker@lshtm.ac.uk{p_end}

{pstd}Eric O. Ohuma{p_end}
{pstd}Maternal, Adolescent, Reproductive, and Child Health (MARCH) Center{p_end}
{pstd}London School of Hygiene and Tropical Medicine{p_end}
{pstd}London, U.K.{p_end}
{pstd}eric.ohuma@lshtm.ac.uk{p_end}


{title:Also see}

{p 4 14 2}Conversion functions: {help ig_nbs:documentation}

{p 4 14 2}Classification functions: {help classify_sga:documentation}

{p 4 14 2}Article: {it:Stata Journal}, volume XX, number X: {browse "https://www.overleaf.com/project/641db63564edd62fb54c963b":st0001}


