// install github module + gigs
// net install github, , from("https://haghish.github.io/github/")
// github install lshtm-gigs/stata-gigs

use "stata-conf-ex2.dta", clear

// Convert z-scores to expected measurements in length/height-for-age standard 
// of the WHO Child Growth Standards
egen double lenht_cm = who_gs(zscore, "lhfa", "z2v"), xvar(age_days) /*
					   */  sex(sex) sexcode(male=2, female=1)

// Convert these weights back to percentiles
egen double zscore_gigs = who_gs(lenht_cm, "lhfa", "v2z"), xvar(age_days) /*
						  */  sex(sex) sexcode(male=2, female=1)
						  
// Convert these weights back to percentiles
egen int stunting = classify_stunting(lenht_cm), /*
					   */  ga_at_birth(gestage) age_days(age) /* 
					   */  lenht_method(len_or_height) lenhtcode(l=L, h=H) /*
                       */  sex(sex) sexcode(male=2, female=1)